using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_Aquarium
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //Textur für das Aquarium
        Texture2D texAquarium;
        //Hintergrundmusik
        SoundEffect sndHintergund;
        //Soundeffekt für die Hintergrundmusik
        SoundEffectInstance seiInstanz;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            //Vollbildmodus
            graphics.IsFullScreen = true;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        protected override void Initialize()
        {
            //Das spriteBatch Objekt bereits in Initialize erstellen!
            //base.Initialize() ruft die DrawableGameComponents auf,
            //die wiederum LoadContent aufrufen, daher steht das spriteBatch Objekt
            //sonst noch nicht zur Verfügung.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            //Das spriteBatch Objekt als Service registrieren.
            //So können die DrawableGameComponents einfach darauf zugreifen
            Services.AddService(typeof(SpriteBatch), spriteBatch);
            //DrawableGameCOmponents für den Kraken, den Seestern und die Fische anlegen
            Components.Add(new Krake(this));
            Components.Add(new Fische(this));
            Components.Add(new Seestern(this));
            base.Initialize();
        }

        protected override void LoadContent()
        {
            //Das Aquarium laden
            texAquarium = Content.Load<Texture2D>("Aquarium1");
            //Hintergrundmusik laden
            sndHintergund = Content.Load<SoundEffect>("AquaLoop");
            //SoundEffectInstance erzeugen
            seiInstanz = sndHintergund.CreateInstance();
            //Wiederholung festlegen
            seiInstanz.IsLooped = true;
            //Lautstärke reduzieren
            seiInstanz.Volume = 0.2F;
            //Abspielen
            seiInstanz.Play();
        }

        protected override void UnloadContent()
        {
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            //SpriteBatch starten
            spriteBatch.Begin();
            //Hintergrund (Das Aquarium) zeichen
            spriteBatch.Draw(texAquarium, new Vector2(0, 0), Color.White);
            //Wegen den DrawableGameComponents base.Draw aufrufen, dann End
            base.Draw(gameTime);
            //Jetzt beenden
            spriteBatch.End();
        }
    }
}
